Subject: Re: kunit alltests runs broken in mainline

From: Jakub Kicinski <[email-masked]>
Date: Mon, 25 Mar 2024 18:52:35 -0700

On Mon, 25 Mar 2024 15:21:33 +0000 Mark Brown wrote:
> Hi,
> 
> Commit 28b3df1fe6ba2cb4 ("kunit: add wireless unit tests") which I can't
> seem to find on lore breaks full kunit runs on non-UML builds and is now
> present in mainline.  If I run:
> 
>    ./tools/testing/kunit/kunit.py run --alltests --cross_compile x86_64-linux-gnu- --arch x86_64
> 
> on a clean tree then I get:
> 
>    [15:09:20] Configuring KUnit Kernel ...
>    Generating .config ...
>    Populating config with:
>    $ make ARCH=x86_64 O=.kunit olddefconfig CROSS_COMPILE=x86_64-linux-gnu-
>    ERROR:root:Not all Kconfig options selected in kunitconfig were in the generated .config.
>    This is probably due to unsatisfied dependencies.
>    Missing: CONFIG_IWLWIFI=y, CONFIG_WLAN_VENDOR_INTEL=y
> 
> UML works fine, but other real architectures (eg, arm64) seem similarly
> broken.  I've not looked properly yet, I'm a bit confused given that
> there's not even any dependencies for WLAN_VENDOR_INTEL and it's not
> mentoned in the defconfig.

I'm late to the party, but FWIW I had to toss this into netdev testing
tree as a local patch:

CONFIG_NETDEVICES=y
CONFIG_WLAN=y
CONFIG_DAMON_DBGFS_DEPRECATED=y
https://github.com/linux-netdev/testing/commit/9a632301bf3dbc9ba553562a0ba2657af6fa84d1

We run using:

	./tools/testing/kunit/kunit.py run --alltests

it got broken after we fast-forwarded to Linus on Thu, so I assumed it
was kunit itself that changed. Not that I found the relevant commit.

The DAMON config was also breaking UML for us, BTW, and I don't see
any fix for that in Linus's tree. Strangeness.